# Class Scrollbar

java.lang.Object
java.awt.Component
java.awt.Scrollbar

All Implemented Interfaces:
  `Adjustable, ImageObserver, MenuContainer, Serializable, Accessible`

public class Scrollbar extends Component implements Adjustable, Accessible
The `Scrollbar` class embodies a scroll bar, a familiar user-interface object. A scroll bar provides a convenient means for allowing a user to select from a range of values. The following three vertical scroll bars could be used as slider controls to pick the red, green, and blue components of a color:

Each scroll bar in this example could be created with code similar to the following:

>     redSlider=new Scrollbar(Scrollbar.VERTICAL, 0, 1, 0, 255);
>     add(redSlider);

Alternatively, a scroll bar can represent a range of values. For example, if a scroll bar is used for scrolling through text, the width of the "bubble" (also called the "thumb" or "scroll box") can be used to represent the amount of text that is visible. Here is an example of a scroll bar that represents a range:

The value range represented by the bubble in this example is the visible amount. The horizontal scroll bar in this example could be created with code like the following:

>     ranger = new Scrollbar(Scrollbar.HORIZONTAL, 0, 60, 0, 300);
>     add(ranger);

Note that the actual maximum value of the scroll bar is the `maximum` minus the `visible amount`. In the previous example, because the `maximum` is 300 and the `visible amount` is 60, the actual maximum value is 240. The range of the scrollbar track is 0 - 300. The left side of the bubble indicates the value of the scroll bar.

Normally, the user changes the value of the scroll bar by making a gesture with the mouse. For example, the user can drag the scroll bar's bubble up and down, or click in the scroll bar's unit increment or block increment areas. Keyboard gestures can also be mapped to the scroll bar. By convention, the Page Up and Page Down keys are equivalent to clicking in the scroll bar's block increment and block decrement areas.

When the user changes the value of the scroll bar, the scroll bar receives an instance of `AdjustmentEvent`. The scroll bar processes this event, passing it along to any registered listeners.

Any object that wishes to be notified of changes to the scroll bar's value should implement `AdjustmentListener`, an interface defined in the package `java.awt.event`. Listeners can be added and removed dynamically by calling the methods `addAdjustmentListener` and `removeAdjustmentListener`.

The `AdjustmentEvent` class defines five types of adjustment event, listed here:

- `AdjustmentEvent.TRACK` is sent out when the user drags the scroll bar's bubble.
- `AdjustmentEvent.UNIT_INCREMENT` is sent out when the user clicks in the left arrow of a horizontal scroll bar, or the top arrow of a vertical scroll bar, or makes the equivalent gesture from the keyboard.
- `AdjustmentEvent.UNIT_DECREMENT` is sent out when the user clicks in the right arrow of a horizontal scroll bar, or the bottom arrow of a vertical scroll bar, or makes the equivalent gesture from the keyboard.
- `AdjustmentEvent.BLOCK_INCREMENT` is sent out when the user clicks in the track, to the left of the bubble on a horizontal scroll bar, or above the bubble on a vertical scroll bar. By convention, the Page Up key is equivalent, if the user is using a keyboard that defines a Page Up key.
- `AdjustmentEvent.BLOCK_DECREMENT` is sent out when the user clicks in the track, to the right of the bubble on a horizontal scroll bar, or below the bubble on a vertical scroll bar. By convention, the Page Down key is equivalent, if the user is using a keyboard that defines a Page Down key.

The JDK 1.0 event system is supported for backwards compatibility, but its use with newer versions of the platform is discouraged. The five types of adjustment events introduced with JDK 1.1 correspond to the five event types that are associated with scroll bars in previous platform versions. The following list gives the adjustment event type, and the corresponding JDK 1.0 event type it replaces.

- `AdjustmentEvent.TRACK` replaces `Event.SCROLL_ABSOLUTE`
- `AdjustmentEvent.UNIT_INCREMENT` replaces `Event.SCROLL_LINE_UP`
- `AdjustmentEvent.UNIT_DECREMENT` replaces `Event.SCROLL_LINE_DOWN`
- `AdjustmentEvent.BLOCK_INCREMENT` replaces `Event.SCROLL_PAGE_UP`
- `AdjustmentEvent.BLOCK_DECREMENT` replaces `Event.SCROLL_PAGE_DOWN`

Note: We recommend using a `Scrollbar` for value selection only. If you want to implement a scrollable component inside a container, we recommend you use a `ScrollPane`. If you use a `Scrollbar` for this purpose, you are likely to encounter issues with painting, key handling, sizing and positioning.

Since:
  1.0
See Also:
  - `AdjustmentEvent`
  - `AdjustmentListener`
  - Serialized Form

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`protected class`
`Scrollbar.AccessibleAWTScrollBar`
This class implements accessibility support for the `Scrollbar` class.

### Nested classes/interfaces declared in class Component

`Component.AccessibleAWTComponent, Component.BaselineResizeBehavior, Component.BltBufferStrategy, Component.FlipBufferStrategy`
Modifier and Type
Class
Description
`protected class`
`Component.AccessibleAWTComponent`
Inner class of Component used to provide default support for accessibility.
`static enum`
`Component.BaselineResizeBehavior`
Enumeration of the common ways the baseline of a component can change as the size changes.
`protected class`
`Component.BltBufferStrategy`
Inner class for blitting offscreen surfaces to a component.
`protected class`
`Component.FlipBufferStrategy`
Inner class for flipping buffers on a component.

## Field Summary

Fields
Modifier and Type
Field
Description
`static final int`
`HORIZONTAL`
A constant that indicates a horizontal scroll bar.
`static final int`
`VERTICAL`
A constant that indicates a vertical scroll bar.

### Fields declared in class Component

`accessibleContext, BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`
Modifier and Type
Field
Description
`protected AccessibleContext`
`accessibleContext`
The `AccessibleContext` associated with this `Component`.
`static final float`
`BOTTOM_ALIGNMENT`
Ease-of-use constant for `getAlignmentY`.
`static final float`
`CENTER_ALIGNMENT`
Ease-of-use constant for `getAlignmentY` and `getAlignmentX`.
`static final float`
`LEFT_ALIGNMENT`
Ease-of-use constant for `getAlignmentX`.
`static final float`
`RIGHT_ALIGNMENT`
Ease-of-use constant for `getAlignmentX`.
`static final float`
`TOP_ALIGNMENT`
Ease-of-use constant for `getAlignmentY()`.

### Fields declared in interface Adjustable

`NO_ORIENTATION`
Modifier and Type
Field
Description
`static final int`
`NO_ORIENTATION`
Indicates that the `Adjustable` has no orientation.

### Fields declared in interface ImageObserver

`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`
Modifier and Type
Field
Description
`static final int`
`ABORT`
This flag in the infoflags argument to imageUpdate indicates that an image which was being tracked asynchronously was aborted before production was complete.
`static final int`
`ALLBITS`
This flag in the infoflags argument to imageUpdate indicates that a static image which was previously drawn is now complete and can be drawn again in its final form.
`static final int`
`ERROR`
This flag in the infoflags argument to imageUpdate indicates that an image which was being tracked asynchronously has encountered an error.
`static final int`
`FRAMEBITS`
This flag in the infoflags argument to imageUpdate indicates that another complete frame of a multi-frame image which was previously drawn is now available to be drawn again.
`static final int`
`HEIGHT`
This flag in the infoflags argument to imageUpdate indicates that the height of the base image is now available and can be taken from the height argument to the imageUpdate callback method.
`static final int`
`PROPERTIES`
This flag in the infoflags argument to imageUpdate indicates that the properties of the image are now available.
`static final int`
`SOMEBITS`
This flag in the infoflags argument to imageUpdate indicates that more pixels needed for drawing a scaled variation of the image are available.
`static final int`
`WIDTH`
This flag in the infoflags argument to imageUpdate indicates that the width of the base image is now available and can be taken from the width argument to the imageUpdate callback method.

## Constructor Summary

Constructors
Constructor
Description
`Scrollbar()`
Constructs a new vertical scroll bar.
`Scrollbar(int orientation)`
Constructs a new scroll bar with the specified orientation.
`Scrollbar(int orientation, int value, int visible, int minimum, int maximum)`
Constructs a new scroll bar with the specified orientation, initial value, visible amount, and minimum and maximum values.

## Method Summary

Modifier and Type
Method
Description
`void`
`addAdjustmentListener(AdjustmentListener l)`
Adds the specified adjustment listener to receive instances of `AdjustmentEvent` from this scroll bar.
`void`
`addNotify()`
Creates the `Scrollbar`'s peer.
`AccessibleContext`
`getAccessibleContext()`
Gets the `AccessibleContext` associated with this `Scrollbar`.
`AdjustmentListener[]`
`getAdjustmentListeners()`
Returns an array of all the adjustment listeners registered on this scrollbar.
`int`
`getBlockIncrement()`
Gets the block increment of this scroll bar.
`int`
`getLineIncrement()`
Deprecated.
As of JDK version 1.1, replaced by `getUnitIncrement()`.
`<T extends EventListener>
T[]`
`getListeners(Class<T> listenerType)`
Returns an array of all the objects currently registered as `FooListener`s upon this `Scrollbar`.
`int`
`getMaximum()`
Gets the maximum value of this scroll bar.
`int`
`getMinimum()`
Gets the minimum value of this scroll bar.
`int`
`getOrientation()`
Returns the orientation of this scroll bar.
`int`
`getPageIncrement()`
Deprecated.
As of JDK version 1.1, replaced by `getBlockIncrement()`.
`int`
`getUnitIncrement()`
Gets the unit increment for this scrollbar.
`int`
`getValue()`
Gets the current value of this scroll bar.
`boolean`
`getValueIsAdjusting()`
Returns true if the value is in the process of changing as a result of actions being taken by the user.
`int`
`getVisible()`
Deprecated.
As of JDK version 1.1, replaced by `getVisibleAmount()`.
`int`
`getVisibleAmount()`
Gets the visible amount of this scroll bar.
`protected String`
`paramString()`
Returns a string representing the state of this `Scrollbar`.
`protected void`
`processAdjustmentEvent(AdjustmentEvent e)`
Processes adjustment events occurring on this scrollbar by dispatching them to any registered `AdjustmentListener` objects.
`protected void`
`processEvent(AWTEvent e)`
Processes events on this scroll bar.
`void`
`removeAdjustmentListener(AdjustmentListener l)`
Removes the specified adjustment listener so that it no longer receives instances of `AdjustmentEvent` from this scroll bar.
`void`
`setBlockIncrement(int v)`
Sets the block increment for this scroll bar.
`void`
`setLineIncrement(int v)`
Deprecated.
As of JDK version 1.1, replaced by `setUnitIncrement(int)`.
`void`
`setMaximum(int newMaximum)`
Sets the maximum value of this scroll bar.
`void`
`setMinimum(int newMinimum)`
Sets the minimum value of this scroll bar.
`void`
`setOrientation(int orientation)`
Sets the orientation for this scroll bar.
`void`
`setPageIncrement(int v)`
Deprecated.
As of JDK version 1.1, replaced by `setBlockIncrement()`.
`void`
`setUnitIncrement(int v)`
Sets the unit increment for this scroll bar.
`void`
`setValue(int newValue)`
Sets the value of this scroll bar to the specified value.
`void`
`setValueIsAdjusting(boolean b)`
Sets the `valueIsAdjusting` property.
`void`
`setValues(int value, int visible, int minimum, int maximum)`
Sets the values of four properties for this scroll bar: `value`, `visibleAmount`, `minimum`, and `maximum`.
`void`
`setVisibleAmount(int newAmount)`
Sets the visible amount of this scroll bar.

### Methods declared in class Component

`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseListener, addMouseMotionListener, addMouseWheelListener, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, bounds, checkImage, checkImage, coalesceEvents, contains, contains, createImage, createImage, createVolatileImage, createVolatileImage, deliverEvent, disable, disableEvents, dispatchEvent, doLayout, enable, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getAlignmentX, getAlignmentY, getBackground, getBaseline, getBaselineResizeBehavior, getBounds, getBounds, getColorModel, getComponentAt, getComponentAt, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeys, getFocusTraversalKeysEnabled, getFont, getFontMetrics, getForeground, getGraphics, getGraphicsConfiguration, getHeight, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocation, getLocationOnScreen, getMaximumSize, getMinimumSize, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPreferredSize, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getSize, getToolkit, getTreeLock, getWidth, getX, getY, gotFocus, handleEvent, hasFocus, hide, imageUpdate, inside, invalidate, isBackgroundSet, isCursorSet, isDisplayable, isDoubleBuffered, isEnabled, isFocusable, isFocusCycleRoot, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isOpaque, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, layout, list, list, list, list, list, locate, location, lostFocus, minimumSize, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paint, paintAll, postEvent, preferredSize, prepareImage, prepareImage, print, printAll, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processKeyEvent, processMouseEvent, processMouseMotionEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseListener, removeMouseMotionListener, removeMouseWheelListener, removeNotify, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, repaint, requestFocus, requestFocus, requestFocus, requestFocus, requestFocusInWindow, requestFocusInWindow, requestFocusInWindow, reshape, resize, resize, revalidate, setBackground, setBounds, setBounds, setComponentOrientation, setCursor, setDropTarget, setEnabled, setFocusable, setFocusTraversalKeys, setFocusTraversalKeysEnabled, setFont, setForeground, setIgnoreRepaint, setLocale, setLocation, setLocation, setMaximumSize, setMinimumSize, setMixingCutoutShape, setName, setPreferredSize, setSize, setSize, setVisible, show, show, size, toString, transferFocus, transferFocusBackward, transferFocusUpCycle, update, validate`
Modifier and Type
Method
Description
`boolean`
`action(Event evt, Object what)`
Deprecated.
As of JDK version 1.1, should register this component as ActionListener on component which fires action events.
`void`
`add(PopupMenu popup)`
Adds the specified popup menu to the component.
`void`
`addComponentListener(ComponentListener l)`
Adds the specified component listener to receive component events from this component.
`void`
`addFocusListener(FocusListener l)`
Adds the specified focus listener to receive focus events from this component when this component gains input focus.
`void`
`addHierarchyBoundsListener(HierarchyBoundsListener l)`
Adds the specified hierarchy bounds listener to receive hierarchy bounds events from this component when the hierarchy to which this container belongs changes.
`void`
`addHierarchyListener(HierarchyListener l)`
Adds the specified hierarchy listener to receive hierarchy changed events from this component when the hierarchy to which this container belongs changes.
`void`
`addInputMethodListener(InputMethodListener l)`
Adds the specified input method listener to receive input method events from this component.
`void`
`addKeyListener(KeyListener l)`
Adds the specified key listener to receive key events from this component.
`void`
`addMouseListener(MouseListener l)`
Adds the specified mouse listener to receive mouse events from this component.
`void`
`addMouseMotionListener(MouseMotionListener l)`
Adds the specified mouse motion listener to receive mouse motion events from this component.
`void`
`addMouseWheelListener(MouseWheelListener l)`
Adds the specified mouse wheel listener to receive mouse wheel events from this component.
`void`
`addPropertyChangeListener(PropertyChangeListener listener)`
Adds a PropertyChangeListener to the listener list.
`void`
`addPropertyChangeListener(String propertyName, PropertyChangeListener listener)`
Adds a PropertyChangeListener to the listener list for a specific property.
`void`
`applyComponentOrientation(ComponentOrientation orientation)`
Sets the `ComponentOrientation` property of this component and all components contained within it.
`boolean`
`areFocusTraversalKeysSet(int id)`
Returns whether the Set of focus traversal keys for the given focus traversal operation has been explicitly defined for this Component.
`Rectangle`
`bounds()`
Deprecated.
As of JDK version 1.1, replaced by `getBounds()`.
`int`
`checkImage(Image image, int width, int height, ImageObserver observer)`
Returns the status of the construction of a screen representation of the specified image.
`int`
`checkImage(Image image, ImageObserver observer)`
Returns the status of the construction of a screen representation of the specified image.
`protected AWTEvent`
`coalesceEvents(AWTEvent existingEvent, AWTEvent newEvent)`
Potentially coalesce an event being posted with an existing event.
`boolean`
`contains(int x, int y)`
Checks whether this component "contains" the specified point, where `x` and `y` are defined to be relative to the coordinate system of this component.
`boolean`
`contains(Point p)`
Checks whether this component "contains" the specified point, where the point's x and y coordinates are defined to be relative to the coordinate system of this component.
`Image`
`createImage(int width, int height)`
Creates an off-screen drawable image to be used for double buffering.
`Image`
`createImage(ImageProducer producer)`
Creates an image from the specified image producer.
`VolatileImage`
`createVolatileImage(int width, int height)`
Creates a volatile off-screen drawable image to be used for double buffering.
`VolatileImage`
`createVolatileImage(int width, int height, ImageCapabilities caps)`
Creates a volatile off-screen drawable image, with the given capabilities.
`void`
`deliverEvent(Event e)`
Deprecated.
As of JDK version 1.1, replaced by `dispatchEvent(AWTEvent e)`.
`void`
`disable()`
Deprecated.
As of JDK version 1.1, replaced by `setEnabled(boolean)`.
`protected final void`
`disableEvents(long eventsToDisable)`
Disables the events defined by the specified event mask parameter from being delivered to this component.
`final void`
`dispatchEvent(AWTEvent e)`
Dispatches an event to this component or one of its sub components.
`void`
`doLayout()`
Prompts the layout manager to lay out this component.
`void`
`enable()`
Deprecated.
As of JDK version 1.1, replaced by `setEnabled(boolean)`.
`void`
`enable(boolean b)`
Deprecated.
As of JDK version 1.1, replaced by `setEnabled(boolean)`.
`protected final void`
`enableEvents(long eventsToEnable)`
Enables the events defined by the specified event mask parameter to be delivered to this component.
`void`
`enableInputMethods(boolean enable)`
Enables or disables input method support for this component.
`protected void`
`firePropertyChange(String propertyName, boolean oldValue, boolean newValue)`
Support for reporting bound property changes for boolean properties.
`void`
`firePropertyChange(String propertyName, byte oldValue, byte newValue)`
Reports a bound property change.
`void`
`firePropertyChange(String propertyName, char oldValue, char newValue)`
Reports a bound property change.
`void`
`firePropertyChange(String propertyName, double oldValue, double newValue)`
Reports a bound property change.
`void`
`firePropertyChange(String propertyName, float oldValue, float newValue)`
Reports a bound property change.
`protected void`
`firePropertyChange(String propertyName, int oldValue, int newValue)`
Support for reporting bound property changes for integer properties.
`void`
`firePropertyChange(String propertyName, long oldValue, long newValue)`
Reports a bound property change.
`void`
`firePropertyChange(String propertyName, short oldValue, short newValue)`
Reports a bound property change.
`protected void`
`firePropertyChange(String propertyName, Object oldValue, Object newValue)`
Support for reporting bound property changes for Object properties.
`float`
`getAlignmentX()`
Returns the alignment along the x axis.
`float`
`getAlignmentY()`
Returns the alignment along the y axis.
`Color`
`getBackground()`
Gets the background color of this component.
`int`
`getBaseline(int width, int height)`
Returns the baseline.
`Component.BaselineResizeBehavior`
`getBaselineResizeBehavior()`
Returns an enum indicating how the baseline of the component changes as the size changes.
`Rectangle`
`getBounds()`
Gets the bounds of this component in the form of a `Rectangle` object.
`Rectangle`
`getBounds(Rectangle rv)`
Stores the bounds of this component into "return value" rv and return rv.
`ColorModel`
`getColorModel()`
Gets the instance of `ColorModel` used to display the component on the output device.
`Component`
`getComponentAt(int x, int y)`
Determines if this component or one of its immediate subcomponents contains the (x, y) location, and if so, returns the containing component.
`Component`
`getComponentAt(Point p)`
Returns the component or subcomponent that contains the specified point.
`ComponentListener[]`
`getComponentListeners()`
Returns an array of all the component listeners registered on this component.
`ComponentOrientation`
`getComponentOrientation()`
Retrieves the language-sensitive orientation that is to be used to order the elements or text within this component.
`Cursor`
`getCursor()`
Gets the cursor set in the component.
`DropTarget`
`getDropTarget()`
Gets the `DropTarget` associated with this `Component`.
`Container`
`getFocusCycleRootAncestor()`
Returns the Container which is the focus cycle root of this Component's focus traversal cycle.
`FocusListener[]`
`getFocusListeners()`
Returns an array of all the focus listeners registered on this component.
`Set<AWTKeyStroke>`
`getFocusTraversalKeys(int id)`
Returns the Set of focus traversal keys for a given traversal operation for this Component.
`boolean`
`getFocusTraversalKeysEnabled()`
Returns whether focus traversal keys are enabled for this Component.
`Font`
`getFont()`
Gets the font of this component.
`FontMetrics`
`getFontMetrics(Font font)`
Gets the font metrics for the specified font.
`Color`
`getForeground()`
Gets the foreground color of this component.
`Graphics`
`getGraphics()`
Creates a graphics context for this component.
`GraphicsConfiguration`
`getGraphicsConfiguration()`
Gets the `GraphicsConfiguration` associated with this `Component`.
`int`
`getHeight()`
Returns the current height of this component.
`HierarchyBoundsListener[]`
`getHierarchyBoundsListeners()`
Returns an array of all the hierarchy bounds listeners registered on this component.
`HierarchyListener[]`
`getHierarchyListeners()`
Returns an array of all the hierarchy listeners registered on this component.
`boolean`
`getIgnoreRepaint()`
Returns whether or not paint messages received from the operating system should be ignored.
`InputContext`
`getInputContext()`
Gets the input context used by this component for handling the communication with input methods when text is entered in this component.
`InputMethodListener[]`
`getInputMethodListeners()`
Returns an array of all the input method listeners registered on this component.
`InputMethodRequests`
`getInputMethodRequests()`
Gets the input method request handler which supports requests from input methods for this component.
`KeyListener[]`
`getKeyListeners()`
Returns an array of all the key listeners registered on this component.
`Locale`
`getLocale()`
Gets the locale of this component.
`Point`
`getLocation()`
Gets the location of this component in the form of a point specifying the component's top-left corner.
`Point`
`getLocation(Point rv)`
Stores the x,y origin of this component into "return value" rv and return rv.
`Point`
`getLocationOnScreen()`
Gets the location of this component in the form of a point specifying the component's top-left corner in the screen's coordinate space.
`Dimension`
`getMaximumSize()`
Gets the maximum size of this component.
`Dimension`
`getMinimumSize()`
Gets the minimum size of this component.
`MouseListener[]`
`getMouseListeners()`
Returns an array of all the mouse listeners registered on this component.
`MouseMotionListener[]`
`getMouseMotionListeners()`
Returns an array of all the mouse motion listeners registered on this component.
`Point`
`getMousePosition()`
Returns the position of the mouse pointer in this `Component`'s coordinate space if the `Component` is directly under the mouse pointer, otherwise returns `null`.
`MouseWheelListener[]`
`getMouseWheelListeners()`
Returns an array of all the mouse wheel listeners registered on this component.
`String`
`getName()`
Gets the name of the component.
`Container`
`getParent()`
Gets the parent of this component.
`Dimension`
`getPreferredSize()`
Gets the preferred size of this component.
`PropertyChangeListener[]`
`getPropertyChangeListeners()`
Returns an array of all the property change listeners registered on this component.
`PropertyChangeListener[]`
`getPropertyChangeListeners(String propertyName)`
Returns an array of all the listeners which have been associated with the named property.
`Dimension`
`getSize()`
Returns the size of this component in the form of a `Dimension` object.
`Dimension`
`getSize(Dimension rv)`
Stores the width/height of this component into "return value" rv and return rv.
`Toolkit`
`getToolkit()`
Gets the toolkit of this component.
`final Object`
`getTreeLock()`
Gets this component's locking object (the object that owns the thread synchronization monitor) for AWT component-tree and layout operations.
`int`
`getWidth()`
Returns the current width of this component.
`int`
`getX()`
Returns the current x coordinate of the components origin.
`int`
`getY()`
Returns the current y coordinate of the components origin.
`boolean`
`gotFocus(Event evt, Object what)`
Deprecated.
As of JDK version 1.1, replaced by processFocusEvent(FocusEvent).
`boolean`
`handleEvent(Event evt)`
Deprecated.
As of JDK version 1.1 replaced by processEvent(AWTEvent).
`boolean`
`hasFocus()`
Returns `true` if this `Component` is the focus owner.
`void`
`hide()`
Deprecated.
As of JDK version 1.1, replaced by `setVisible(boolean)`.
`boolean`
`imageUpdate(Image img, int infoflags, int x, int y, int w, int h)`
Repaints the component when the image has changed.
`boolean`
`inside(int x, int y)`
Deprecated.
As of JDK version 1.1, replaced by contains(int, int).
`void`
`invalidate()`
Invalidates this component and its ancestors.
`boolean`
`isBackgroundSet()`
Returns whether the background color has been explicitly set for this Component.
`boolean`
`isCursorSet()`
Returns whether the cursor has been explicitly set for this Component.
`boolean`
`isDisplayable()`
Determines whether this component is displayable.
`boolean`
`isDoubleBuffered()`
Returns true if this component is painted to an offscreen image ("buffer") that's copied to the screen later.
`boolean`
`isEnabled()`
Determines whether this component is enabled.
`boolean`
`isFocusable()`
Returns whether this Component can be focused.
`boolean`
`isFocusCycleRoot(Container container)`
Returns whether the specified Container is the focus cycle root of this Component's focus traversal cycle.
`boolean`
`isFocusOwner()`
Returns `true` if this `Component` is the focus owner.
`boolean`
`isFocusTraversable()`
Deprecated.
As of 1.4, replaced by `isFocusable()`.
`boolean`
`isFontSet()`
Returns whether the font has been explicitly set for this Component.
`boolean`
`isForegroundSet()`
Returns whether the foreground color has been explicitly set for this Component.
`boolean`
`isLightweight()`
A lightweight component doesn't have a native toolkit peer.
`boolean`
`isMaximumSizeSet()`
Returns true if the maximum size has been set to a non-`null` value otherwise returns false.
`boolean`
`isMinimumSizeSet()`
Returns whether or not `setMinimumSize` has been invoked with a non-null value.
`boolean`
`isOpaque()`
Returns true if this component is completely opaque, returns false by default.
`boolean`
`isPreferredSizeSet()`
Returns true if the preferred size has been set to a non-`null` value otherwise returns false.
`boolean`
`isShowing()`
Determines whether this component is showing on screen.
`boolean`
`isValid()`
Determines whether this component is valid.
`boolean`
`isVisible()`
Determines whether this component should be visible when its parent is visible.
`boolean`
`keyDown(Event evt, int key)`
Deprecated.
As of JDK version 1.1, replaced by processKeyEvent(KeyEvent).
`boolean`
`keyUp(Event evt, int key)`
Deprecated.
As of JDK version 1.1, replaced by processKeyEvent(KeyEvent).
`void`
`layout()`
Deprecated.
As of JDK version 1.1, replaced by `doLayout()`.
`void`
`list()`
Prints a listing of this component to the standard system output stream `System.out`.
`void`
`list(PrintStream out)`
Prints a listing of this component to the specified output stream.
`void`
`list(PrintStream out, int indent)`
Prints out a list, starting at the specified indentation, to the specified print stream.
`void`
`list(PrintWriter out)`
Prints a listing to the specified print writer.
`void`
`list(PrintWriter out, int indent)`
Prints out a list, starting at the specified indentation, to the specified print writer.
`Component`
`locate(int x, int y)`
Deprecated.
As of JDK version 1.1, replaced by getComponentAt(int, int).
`Point`
`location()`
Deprecated.
As of JDK version 1.1, replaced by `getLocation()`.
`boolean`
`lostFocus(Event evt, Object what)`
Deprecated.
As of JDK version 1.1, replaced by processFocusEvent(FocusEvent).
`Dimension`
`minimumSize()`
Deprecated.
As of JDK version 1.1, replaced by `getMinimumSize()`.
`boolean`
`mouseDown(Event evt, int x, int y)`
Deprecated.
As of JDK version 1.1, replaced by processMouseEvent(MouseEvent).
`boolean`
`mouseDrag(Event evt, int x, int y)`
Deprecated.
As of JDK version 1.1, replaced by processMouseMotionEvent(MouseEvent).
`boolean`
`mouseEnter(Event evt, int x, int y)`
Deprecated.
As of JDK version 1.1, replaced by processMouseEvent(MouseEvent).
`boolean`
`mouseExit(Event evt, int x, int y)`
Deprecated.
As of JDK version 1.1, replaced by processMouseEvent(MouseEvent).
`boolean`
`mouseMove(Event evt, int x, int y)`
Deprecated.
As of JDK version 1.1, replaced by processMouseMotionEvent(MouseEvent).
`boolean`
`mouseUp(Event evt, int x, int y)`
Deprecated.
As of JDK version 1.1, replaced by processMouseEvent(MouseEvent).
`void`
`move(int x, int y)`
Deprecated.
As of JDK version 1.1, replaced by `setLocation(int, int)`.
`void`
`nextFocus()`
Deprecated.
As of JDK version 1.1, replaced by transferFocus().
`void`
`paint(Graphics g)`
Paints this component.
`void`
`paintAll(Graphics g)`
Paints this component and all of its subcomponents.
`boolean`
`postEvent(Event e)`
Deprecated.
As of JDK version 1.1, replaced by dispatchEvent(AWTEvent).
`Dimension`
`preferredSize()`
Deprecated.
As of JDK version 1.1, replaced by `getPreferredSize()`.
`boolean`
`prepareImage(Image image, int width, int height, ImageObserver observer)`
Prepares an image for rendering on this component at the specified width and height.
`boolean`
`prepareImage(Image image, ImageObserver observer)`
Prepares an image for rendering on this component.
`void`
`print(Graphics g)`
Prints this component.
`void`
`printAll(Graphics g)`
Prints this component and all of its subcomponents.
`protected void`
`processComponentEvent(ComponentEvent e)`
Processes component events occurring on this component by dispatching them to any registered `ComponentListener` objects.
`protected void`
`processFocusEvent(FocusEvent e)`
Processes focus events occurring on this component by dispatching them to any registered `FocusListener` objects.
`protected void`
`processHierarchyBoundsEvent(HierarchyEvent e)`
Processes hierarchy bounds events occurring on this component by dispatching them to any registered `HierarchyBoundsListener` objects.
`protected void`
`processHierarchyEvent(HierarchyEvent e)`
Processes hierarchy events occurring on this component by dispatching them to any registered `HierarchyListener` objects.
`protected void`
`processInputMethodEvent(InputMethodEvent e)`
Processes input method events occurring on this component by dispatching them to any registered `InputMethodListener` objects.
`protected void`
`processKeyEvent(KeyEvent e)`
Processes key events occurring on this component by dispatching them to any registered `KeyListener` objects.
`protected void`
`processMouseEvent(MouseEvent e)`
Processes mouse events occurring on this component by dispatching them to any registered `MouseListener` objects.
`protected void`
`processMouseMotionEvent(MouseEvent e)`
Processes mouse motion events occurring on this component by dispatching them to any registered `MouseMotionListener` objects.
`protected void`
`processMouseWheelEvent(MouseWheelEvent e)`
Processes mouse wheel events occurring on this component by dispatching them to any registered `MouseWheelListener` objects.
`void`
`remove(MenuComponent popup)`
Removes the specified popup menu from the component.
`void`
`removeComponentListener(ComponentListener l)`
Removes the specified component listener so that it no longer receives component events from this component.
`void`
`removeFocusListener(FocusListener l)`
Removes the specified focus listener so that it no longer receives focus events from this component.
`void`
`removeHierarchyBoundsListener(HierarchyBoundsListener l)`
Removes the specified hierarchy bounds listener so that it no longer receives hierarchy bounds events from this component.
`void`
`removeHierarchyListener(HierarchyListener l)`
Removes the specified hierarchy listener so that it no longer receives hierarchy changed events from this component.
`void`
`removeInputMethodListener(InputMethodListener l)`
Removes the specified input method listener so that it no longer receives input method events from this component.
`void`
`removeKeyListener(KeyListener l)`
Removes the specified key listener so that it no longer receives key events from this component.
`void`
`removeMouseListener(MouseListener l)`
Removes the specified mouse listener so that it no longer receives mouse events from this component.
`void`
`removeMouseMotionListener(MouseMotionListener l)`
Removes the specified mouse motion listener so that it no longer receives mouse motion events from this component.
`void`
`removeMouseWheelListener(MouseWheelListener l)`
Removes the specified mouse wheel listener so that it no longer receives mouse wheel events from this component.
`void`
`removeNotify()`
Makes this `Component` undisplayable by destroying it native screen resource.
`void`
`removePropertyChangeListener(PropertyChangeListener listener)`
Removes a PropertyChangeListener from the listener list.
`void`
`removePropertyChangeListener(String propertyName, PropertyChangeListener listener)`
Removes a `PropertyChangeListener` from the listener list for a specific property.
`void`
`repaint()`
Repaints this component.
`void`
`repaint(int x, int y, int width, int height)`
Repaints the specified rectangle of this component.
`void`
`repaint(long tm)`
Repaints the component.
`void`
`repaint(long tm, int x, int y, int width, int height)`
Repaints the specified rectangle of this component within `tm` milliseconds.
`void`
`requestFocus()`
Requests that this Component get the input focus, and that this Component's top-level ancestor become the focused Window.
`protected boolean`
`requestFocus(boolean temporary)`
Requests that this `Component` get the input focus, and that this `Component`'s top-level ancestor become the focused `Window`.
`protected boolean`
`requestFocus(boolean temporary, FocusEvent.Cause cause)`
Requests by the reason of `cause` that this `Component` get the input focus, and that this `Component`'s top-level ancestor become the focused `Window`.
`void`
`requestFocus(FocusEvent.Cause cause)`
Requests by the reason of `cause` that this Component get the input focus, and that this Component's top-level ancestor become the focused Window.
`boolean`
`requestFocusInWindow()`
Requests that this Component get the input focus, if this Component's top-level ancestor is already the focused Window.
`protected boolean`
`requestFocusInWindow(boolean temporary)`
Requests that this `Component` get the input focus, if this `Component`'s top-level ancestor is already the focused `Window`.
`boolean`
`requestFocusInWindow(FocusEvent.Cause cause)`
Requests by the reason of `cause` that this Component get the input focus, if this Component's top-level ancestor is already the focused Window.
`void`
`reshape(int x, int y, int width, int height)`
Deprecated.
As of JDK version 1.1, replaced by `setBounds(int, int, int, int)`.
`void`
`resize(int width, int height)`
Deprecated.
As of JDK version 1.1, replaced by `setSize(int, int)`.
`void`
`resize(Dimension d)`
Deprecated.
As of JDK version 1.1, replaced by `setSize(Dimension)`.
`void`
`revalidate()`
Revalidates the component hierarchy up to the nearest validate root.
`void`
`setBackground(Color c)`
Sets the background color of this component.
`void`
`setBounds(int x, int y, int width, int height)`
Moves and resizes this component.
`void`
`setBounds(Rectangle r)`
Moves and resizes this component to conform to the new bounding rectangle `r`.
`void`
`setComponentOrientation(ComponentOrientation o)`
Sets the language-sensitive orientation that is to be used to order the elements or text within this component.
`void`
`setCursor(Cursor cursor)`
Sets the cursor image to the specified cursor.
`void`
`setDropTarget(DropTarget dt)`
Associate a `DropTarget` with this component.
`void`
`setEnabled(boolean b)`
Enables or disables this component, depending on the value of the parameter `b`.
`void`
`setFocusable(boolean focusable)`
Sets the focusable state of this Component to the specified value.
`void`
`setFocusTraversalKeys(int id, Set<? extends AWTKeyStroke> keystrokes)`
Sets the focus traversal keys for a given traversal operation for this Component.
`void`
`setFocusTraversalKeysEnabled(boolean focusTraversalKeysEnabled)`
Sets whether focus traversal keys are enabled for this Component.
`void`
`setFont(Font f)`
Sets the font of this component.
`void`
`setForeground(Color c)`
Sets the foreground color of this component.
`void`
`setIgnoreRepaint(boolean ignoreRepaint)`
Sets whether or not paint messages received from the operating system should be ignored.
`void`
`setLocale(Locale l)`
Sets the locale of this component.
`void`
`setLocation(int x, int y)`
Moves this component to a new location.
`void`
`setLocation(Point p)`
Moves this component to a new location.
`void`
`setMaximumSize(Dimension maximumSize)`
Sets the maximum size of this component to a constant value.
`void`
`setMinimumSize(Dimension minimumSize)`
Sets the minimum size of this component to a constant value.
`void`
`setMixingCutoutShape(Shape shape)`
Sets a 'mixing-cutout' shape for this lightweight component.
`void`
`setName(String name)`
Sets the name of the component to the specified string.
`void`
`setPreferredSize(Dimension preferredSize)`
Sets the preferred size of this component to a constant value.
`void`
`setSize(int width, int height)`
Resizes this component so that it has width `width` and height `height`.
`void`
`setSize(Dimension d)`
Resizes this component so that it has width `d.width` and height `d.height`.
`void`
`setVisible(boolean b)`
Shows or hides this component depending on the value of parameter `b`.
`void`
`show()`
Deprecated.
As of JDK version 1.1, replaced by `setVisible(boolean)`.
`void`
`show(boolean b)`
Deprecated.
As of JDK version 1.1, replaced by `setVisible(boolean)`.
`Dimension`
`size()`
Deprecated.
As of JDK version 1.1, replaced by `getSize()`.
`String`
`toString()`
Returns a string representation of this component and its values.
`void`
`transferFocus()`
Transfers the focus to the next component, as though this Component were the focus owner.
`void`
`transferFocusBackward()`
Transfers the focus to the previous component, as though this Component were the focus owner.
`void`
`transferFocusUpCycle()`
Transfers the focus up one focus traversal cycle.
`void`
`update(Graphics g)`
Updates this component.
`void`
`validate()`
Validates this component.

### Methods declared in class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`
Modifier and Type
Method
Description
`protected Object`
`clone()`
Creates and returns a copy of this object.
`boolean`
`equals(Object obj)`
Indicates whether some other object is "equal to" this one.
`protected void`
`finalize()`
Deprecated, for removal: This API element is subject to removal in a future version.
Finalization is deprecated and subject to removal in a future release.
`final Class<?>`
`getClass()`
Returns the runtime class of this `Object`.
`int`
`hashCode()`
Returns a hash code value for this object.
`final void`
`notify()`
Wakes up a single thread that is waiting on this object's monitor.
`final void`
`notifyAll()`
Wakes up all threads that are waiting on this object's monitor.
`final void`
`wait()`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted.
`final void`
`wait(long timeoutMillis)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.
`final void`
`wait(long timeoutMillis, int nanos)`
Causes the current thread to wait until it is awakened, typically by being notified or interrupted, or until a certain amount of real time has elapsed.

## Field Details

### HORIZONTAL

public static final int HORIZONTAL
A constant that indicates a horizontal scroll bar.

See Also:
  - Constant Field Values

### VERTICAL

public static final int VERTICAL
A constant that indicates a vertical scroll bar.

See Also:
  - Constant Field Values

## Constructor Details

### Scrollbar

public Scrollbar() throws HeadlessException
Constructs a new vertical scroll bar. The default properties of the scroll bar are listed in the following table:

Scrollbar default properties
Property | Description | Default Value
--- | --- | ---
orientation | indicates whether the scroll bar is vertical or horizontal | `Scrollbar.VERTICAL`
value | value which controls the location of the scroll bar's bubble | 0
visible amount | visible amount of the scroll bar's range, typically represented by the size of the scroll bar's bubble | 10
minimum | minimum value of the scroll bar | 0
maximum | maximum value of the scroll bar | 100
unit increment | amount the value changes when the Line Up or Line Down key is pressed, or when the end arrows of the scrollbar are clicked | 1
block increment | amount the value changes when the Page Up or Page Down key is pressed, or when the scrollbar track is clicked on either side of the bubble | 10

Throws:
  `HeadlessException` - if GraphicsEnvironment.isHeadless() returns true.
See Also:
  - `GraphicsEnvironment.isHeadless()`

### Scrollbar

public Scrollbar(int orientation) throws HeadlessException
Constructs a new scroll bar with the specified orientation.

The `orientation` argument must take one of the two values `Scrollbar.HORIZONTAL`, or `Scrollbar.VERTICAL`, indicating a horizontal or vertical scroll bar, respectively.

Parameters:
  `orientation` - indicates the orientation of the scroll bar
Throws:
  `IllegalArgumentException` - when an illegal value for the `orientation` argument is supplied
  `HeadlessException` - if GraphicsEnvironment.isHeadless() returns true.
See Also:
  - `GraphicsEnvironment.isHeadless()`

### Scrollbar

public Scrollbar(int orientation, int value, int visible, int minimum, int maximum) throws HeadlessException
Constructs a new scroll bar with the specified orientation, initial value, visible amount, and minimum and maximum values.

The `orientation` argument must take one of the two values `Scrollbar.HORIZONTAL`, or `Scrollbar.VERTICAL`, indicating a horizontal or vertical scroll bar, respectively.

The parameters supplied to this constructor are subject to the constraints described in `setValues(int, int, int, int)`.

Parameters:
  `orientation` - indicates the orientation of the scroll bar.
  `value` - the initial value of the scroll bar
  `visible` - the visible amount of the scroll bar, typically represented by the size of the bubble
  `minimum` - the minimum value of the scroll bar
  `maximum` - the maximum value of the scroll bar
Throws:
  `IllegalArgumentException` - when an illegal value for the `orientation` argument is supplied
  `HeadlessException` - if GraphicsEnvironment.isHeadless() returns true.
See Also:
  - `setValues(int, int, int, int)`
  - `GraphicsEnvironment.isHeadless()`

## Method Details

### addNotify

public void addNotify()
Creates the `Scrollbar`'s peer. The peer allows you to modify the appearance of the `Scrollbar` without changing any of its functionality.

Overrides:
  `addNotify` in class `Component`
See Also:
  - `Component.isDisplayable()`
  - `Component.removeNotify()`
  - `Component.invalidate()`

### getOrientation

public int getOrientation()
Returns the orientation of this scroll bar.

Specified by:
  `getOrientation` in interface `Adjustable`
Returns:
  the orientation of this scroll bar, either `Scrollbar.HORIZONTAL` or `Scrollbar.VERTICAL`
See Also:
  - `setOrientation(int)`

### setOrientation

public void setOrientation(int orientation)
Sets the orientation for this scroll bar.

Parameters:
  `orientation` - the orientation of this scroll bar, either `Scrollbar.HORIZONTAL` or `Scrollbar.VERTICAL`
Throws:
  `IllegalArgumentException` - if the value supplied for `orientation` is not a legal value
Since:
  1.1
See Also:
  - `getOrientation()`

### getValue

public int getValue()
Gets the current value of this scroll bar.

Specified by:
  `getValue` in interface `Adjustable`
Returns:
  the current value of this scroll bar
See Also:
  - `getMinimum()`
  - `getMaximum()`

### setValue

public void setValue(int newValue)
Sets the value of this scroll bar to the specified value.

If the value supplied is less than the current `minimum` or greater than the current `maximum - visibleAmount`, then either `minimum` or `maximum - visibleAmount` is substituted, as appropriate.

Normally, a program should change a scroll bar's value only by calling `setValues`. The `setValues` method simultaneously and synchronously sets the minimum, maximum, visible amount, and value properties of a scroll bar, so that they are mutually consistent.

Calling this method does not fire an `AdjustmentEvent`.

Specified by:
  `setValue` in interface `Adjustable`
Parameters:
  `newValue` - the new value of the scroll bar
See Also:
  - `setValues(int, int, int, int)`
  - `getValue()`
  - `getMinimum()`
  - `getMaximum()`

### getMinimum

public int getMinimum()
Gets the minimum value of this scroll bar.

Specified by:
  `getMinimum` in interface `Adjustable`
Returns:
  the minimum value of this scroll bar
See Also:
  - `getValue()`
  - `getMaximum()`

### setMinimum

public void setMinimum(int newMinimum)
Sets the minimum value of this scroll bar.

When `setMinimum` is called, the minimum value is changed, and other values (including the maximum, the visible amount, and the current scroll bar value) are changed to be consistent with the new minimum.

Normally, a program should change a scroll bar's minimum value only by calling `setValues`. The `setValues` method simultaneously and synchronously sets the minimum, maximum, visible amount, and value properties of a scroll bar, so that they are mutually consistent.

Note that setting the minimum value to `Integer.MAX_VALUE` will result in the new minimum value being set to `Integer.MAX_VALUE - 1`.

Specified by:
  `setMinimum` in interface `Adjustable`
Parameters:
  `newMinimum` - the new minimum value for this scroll bar
Since:
  1.1
See Also:
  - `setValues(int, int, int, int)`
  - `setMaximum(int)`

### getMaximum

public int getMaximum()
Gets the maximum value of this scroll bar.

Specified by:
  `getMaximum` in interface `Adjustable`
Returns:
  the maximum value of this scroll bar
See Also:
  - `getValue()`
  - `getMinimum()`

### setMaximum

public void setMaximum(int newMaximum)
Sets the maximum value of this scroll bar.

When `setMaximum` is called, the maximum value is changed, and other values (including the minimum, the visible amount, and the current scroll bar value) are changed to be consistent with the new maximum.

Normally, a program should change a scroll bar's maximum value only by calling `setValues`. The `setValues` method simultaneously and synchronously sets the minimum, maximum, visible amount, and value properties of a scroll bar, so that they are mutually consistent.

Note that setting the maximum value to `Integer.MIN_VALUE` will result in the new maximum value being set to `Integer.MIN_VALUE + 1`.

Specified by:
  `setMaximum` in interface `Adjustable`
Parameters:
  `newMaximum` - the new maximum value for this scroll bar
Since:
  1.1
See Also:
  - `setValues(int, int, int, int)`
  - `setMinimum(int)`

### getVisibleAmount

public int getVisibleAmount()
Gets the visible amount of this scroll bar.

When a scroll bar is used to select a range of values, the visible amount is used to represent the range of values that are currently visible. The size of the scroll bar's bubble (also called a thumb or scroll box), usually gives a visual representation of the relationship of the visible amount to the range of the scroll bar. Note that depending on platform, the value of the visible amount property may not be visually indicated by the size of the bubble.

The scroll bar's bubble may not be displayed when it is not moveable (e.g. when it takes up the entire length of the scroll bar's track, or when the scroll bar is disabled). Whether the bubble is displayed or not will not affect the value returned by `getVisibleAmount`.

Specified by:
  `getVisibleAmount` in interface `Adjustable`
Returns:
  the visible amount of this scroll bar
Since:
  1.1
See Also:
  - `setVisibleAmount(int)`

### getVisible

@Deprecated public int getVisible()
Deprecated.
As of JDK version 1.1, replaced by `getVisibleAmount()`.
Returns the visible amount of this scroll bar.

Returns:
  the visible amount of this scroll bar

### setVisibleAmount

public void setVisibleAmount(int newAmount)
Sets the visible amount of this scroll bar.

When a scroll bar is used to select a range of values, the visible amount is used to represent the range of values that are currently visible. The size of the scroll bar's bubble (also called a thumb or scroll box), usually gives a visual representation of the relationship of the visible amount to the range of the scroll bar. Note that depending on platform, the value of the visible amount property may not be visually indicated by the size of the bubble.

The scroll bar's bubble may not be displayed when it is not moveable (e.g. when it takes up the entire length of the scroll bar's track, or when the scroll bar is disabled). Whether the bubble is displayed or not will not affect the value returned by `getVisibleAmount`.

If the visible amount supplied is less than `one` or greater than the current `maximum - minimum`, then either `one` or `maximum - minimum` is substituted, as appropriate.

Normally, a program should change a scroll bar's value only by calling `setValues`. The `setValues` method simultaneously and synchronously sets the minimum, maximum, visible amount, and value properties of a scroll bar, so that they are mutually consistent.

Specified by:
  `setVisibleAmount` in interface `Adjustable`
Parameters:
  `newAmount` - the new visible amount
Since:
  1.1
See Also:
  - `getVisibleAmount()`
  - `setValues(int, int, int, int)`

### setUnitIncrement

public void setUnitIncrement(int v)
Sets the unit increment for this scroll bar.

The unit increment is the value that is added or subtracted when the user activates the unit increment area of the scroll bar, generally through a mouse or keyboard gesture that the scroll bar receives as an adjustment event. The unit increment must be greater than zero. Attempts to set the unit increment to a value lower than 1 will result in a value of 1 being set.

In some operating systems, this property can be ignored by the underlying controls.

Specified by:
  `setUnitIncrement` in interface `Adjustable`
Parameters:
  `v` - the amount by which to increment or decrement the scroll bar's value
Since:
  1.1
See Also:
  - `getUnitIncrement()`

### setLineIncrement

@Deprecated public void setLineIncrement(int v)
Deprecated.
As of JDK version 1.1, replaced by `setUnitIncrement(int)`.
Sets the unit increment for this scroll bar.

Parameters:
  `v` - the increment value

### getUnitIncrement

public int getUnitIncrement()
Gets the unit increment for this scrollbar.

The unit increment is the value that is added or subtracted when the user activates the unit increment area of the scroll bar, generally through a mouse or keyboard gesture that the scroll bar receives as an adjustment event. The unit increment must be greater than zero.

In some operating systems, this property can be ignored by the underlying controls.

Specified by:
  `getUnitIncrement` in interface `Adjustable`
Returns:
  the unit increment of this scroll bar
Since:
  1.1
See Also:
  - `setUnitIncrement(int)`

### getLineIncrement

@Deprecated public int getLineIncrement()
Deprecated.
As of JDK version 1.1, replaced by `getUnitIncrement()`.
Returns the unit increment for this scrollbar.

Returns:
  the unit increment for this scrollbar

### setBlockIncrement

public void setBlockIncrement(int v)
Sets the block increment for this scroll bar.

The block increment is the value that is added or subtracted when the user activates the block increment area of the scroll bar, generally through a mouse or keyboard gesture that the scroll bar receives as an adjustment event. The block increment must be greater than zero. Attempts to set the block increment to a value lower than 1 will result in a value of 1 being set.

Specified by:
  `setBlockIncrement` in interface `Adjustable`
Parameters:
  `v` - the amount by which to increment or decrement the scroll bar's value
Since:
  1.1
See Also:
  - `getBlockIncrement()`

### setPageIncrement

@Deprecated public void setPageIncrement(int v)
Deprecated.
As of JDK version 1.1, replaced by `setBlockIncrement()`.
Sets the block increment for this scroll bar.

Parameters:
  `v` - the block increment

### getBlockIncrement

public int getBlockIncrement()
Gets the block increment of this scroll bar.

The block increment is the value that is added or subtracted when the user activates the block increment area of the scroll bar, generally through a mouse or keyboard gesture that the scroll bar receives as an adjustment event. The block increment must be greater than zero.

Specified by:
  `getBlockIncrement` in interface `Adjustable`
Returns:
  the block increment of this scroll bar
Since:
  1.1
See Also:
  - `setBlockIncrement(int)`

### getPageIncrement

@Deprecated public int getPageIncrement()
Deprecated.
As of JDK version 1.1, replaced by `getBlockIncrement()`.
Returns the block increment of this scroll bar.

Returns:
  the block increment of this scroll bar

### setValues

public void setValues(int value, int visible, int minimum, int maximum)
Sets the values of four properties for this scroll bar: `value`, `visibleAmount`, `minimum`, and `maximum`. If the values supplied for these properties are inconsistent or incorrect, they will be changed to ensure consistency.

This method simultaneously and synchronously sets the values of four scroll bar properties, assuring that the values of these properties are mutually consistent. It enforces the following constraints: `maximum` must be greater than `minimum`, `maximum - minimum` must not be greater than `Integer.MAX_VALUE`, `visibleAmount` must be greater than zero. `visibleAmount` must not be greater than `maximum - minimum`, `value` must not be less than `minimum`, and `value` must not be greater than `maximum - visibleAmount`

Calling this method does not fire an `AdjustmentEvent`.

Parameters:
  `value` - is the position in the current window
  `visible` - is the visible amount of the scroll bar
  `minimum` - is the minimum value of the scroll bar
  `maximum` - is the maximum value of the scroll bar
See Also:
  - `setMinimum(int)`
  - `setMaximum(int)`
  - `setVisibleAmount(int)`
  - `setValue(int)`

### getValueIsAdjusting

public boolean getValueIsAdjusting()
Returns true if the value is in the process of changing as a result of actions being taken by the user.

Returns:
  the value of the `valueIsAdjusting` property
Since:
  1.4
See Also:
  - `setValueIsAdjusting(boolean)`

### setValueIsAdjusting

public void setValueIsAdjusting(boolean b)
Sets the `valueIsAdjusting` property.

Parameters:
  `b` - new adjustment-in-progress status
Since:
  1.4
See Also:
  - `getValueIsAdjusting()`

### addAdjustmentListener

public void addAdjustmentListener(AdjustmentListener l)
Adds the specified adjustment listener to receive instances of `AdjustmentEvent` from this scroll bar. If l is `null`, no exception is thrown and no action is performed.

Refer to AWT Threading Issues for details on AWT's threading model.

Specified by:
  `addAdjustmentListener` in interface `Adjustable`
Parameters:
  `l` - the adjustment listener
Since:
  1.1
See Also:
  - `removeAdjustmentListener(AdjustmentListener)`
  - `getAdjustmentListeners()`
  - `AdjustmentEvent`
  - `AdjustmentListener`

### removeAdjustmentListener

public void removeAdjustmentListener(AdjustmentListener l)
Removes the specified adjustment listener so that it no longer receives instances of `AdjustmentEvent` from this scroll bar. If l is `null`, no exception is thrown and no action is performed.

Refer to AWT Threading Issues for details on AWT's threading model.

Specified by:
  `removeAdjustmentListener` in interface `Adjustable`
Parameters:
  `l` - the adjustment listener
Since:
  1.1
See Also:
  - `addAdjustmentListener(AdjustmentListener)`
  - `getAdjustmentListeners()`
  - `AdjustmentEvent`
  - `AdjustmentListener`

### getAdjustmentListeners

public AdjustmentListener[] getAdjustmentListeners()
Returns an array of all the adjustment listeners registered on this scrollbar.

Returns:
  all of this scrollbar's `AdjustmentListener`s or an empty array if no adjustment listeners are currently registered
Since:
  1.4
See Also:
  - `addAdjustmentListener(AdjustmentListener)`
  - `removeAdjustmentListener(AdjustmentListener)`
  - `AdjustmentEvent`
  - `AdjustmentListener`

### getListeners

public <T extends EventListener> T[] getListeners(Class<T> listenerType)
Returns an array of all the objects currently registered as `FooListener`s upon this `Scrollbar`. `FooListener`s are registered using the `addFooListener` method.

You can specify the `listenerType` argument with a class literal, such as `FooListener.class`. For example, you can query a `Scrollbar c` for its mouse listeners with the following code:

    MouseListener[] mls = (MouseListener[])(c.getListeners(MouseListener.class));

If no such listeners exist, this method returns an empty array.

Overrides:
  `getListeners` in class `Component`
Type Parameters:
  `T` - the type of the listeners
Parameters:
  `listenerType` - the type of listeners requested; this parameter should specify an interface that descends from `java.util.EventListener`
Returns:
  an array of all objects registered as `FooListener`s on this component, or an empty array if no such listeners have been added
Throws:
  `ClassCastException` - if `listenerType` doesn't specify a class or interface that implements `java.util.EventListener`
Since:
  1.3
See Also:
  - `Component.getComponentListeners()`
  - `Component.getFocusListeners()`
  - `Component.getHierarchyListeners()`
  - `Component.getHierarchyBoundsListeners()`
  - `Component.getKeyListeners()`
  - `Component.getMouseListeners()`
  - `Component.getMouseMotionListeners()`
  - `Component.getMouseWheelListeners()`
  - `Component.getInputMethodListeners()`
  - `Component.getPropertyChangeListeners()`

### processEvent

protected void processEvent(AWTEvent e)
Processes events on this scroll bar. If the event is an instance of `AdjustmentEvent`, it invokes the `processAdjustmentEvent` method. Otherwise, it invokes its superclass's `processEvent` method.

Note that if the event parameter is `null` the behavior is unspecified and may result in an exception.

Overrides:
  `processEvent` in class `Component`
Parameters:
  `e` - the event
Since:
  1.1
See Also:
  - `AdjustmentEvent`
  - `processAdjustmentEvent(AdjustmentEvent)`

### processAdjustmentEvent

protected void processAdjustmentEvent(AdjustmentEvent e)
Processes adjustment events occurring on this scrollbar by dispatching them to any registered `AdjustmentListener` objects.

This method is not called unless adjustment events are enabled for this component. Adjustment events are enabled when one of the following occurs:

- An `AdjustmentListener` object is registered via `addAdjustmentListener`.
- Adjustment events are enabled via `enableEvents`.

Note that if the event parameter is `null` the behavior is unspecified and may result in an exception.

Parameters:
  `e` - the adjustment event
Since:
  1.1
See Also:
  - `AdjustmentEvent`
  - `AdjustmentListener`
  - `addAdjustmentListener(AdjustmentListener)`
  - `Component.enableEvents(long)`

### paramString

protected String paramString()
Returns a string representing the state of this `Scrollbar`. This method is intended to be used only for debugging purposes, and the content and format of the returned string may vary between implementations. The returned string may be empty but may not be `null`.

Overrides:
  `paramString` in class `Component`
Returns:
  the parameter string of this scroll bar

### getAccessibleContext

public AccessibleContext getAccessibleContext()
Gets the `AccessibleContext` associated with this `Scrollbar`. For scrollbars, the `AccessibleContext` takes the form of an `AccessibleAWTScrollBar`. A new `AccessibleAWTScrollBar` instance is created if necessary.

Specified by:
  `getAccessibleContext` in interface `Accessible`
Overrides:
  `getAccessibleContext` in class `Component`
Returns:
  an `AccessibleAWTScrollBar` that serves as the `AccessibleContext` of this `ScrollBar`
Since:
  1.3